/*
	PWM secca
	Date:		16/09/2014
	Target:	Cyclone IV
	Board:	DE0-NANO
	
 OBIETTIVO:
 ----------
 semplicissima PWM su un solo pin.
*/

module PWM
(	input clk,								// clock
	input syncEnable,						// Abilitazione per la commutazione
	input signed [31:0]	mod,			// modulante o duty-cycle da applicare
	input signed [31:0]	carrier,		// portante
	output P									// comando P secco
);

reg CommEnable = 0;						// Commutation Allowed
reg C = 1'b0;								// comandi della PWM
reg Cm = 1'b0;								// mirror comando PWM

always @(posedge syncEnable or posedge clk)
begin
	if(syncEnable)
	begin
		Cm = C;						// memorizzo lo stato della PWM
		CommEnable = 1'b1;		// riabilito la commutazione
	end
	else
	if(Cm ^ C)
		CommEnable = 1'b0;		// disabilito la commutazione
end

// Generazione della commutazione pura senza tempo morto
always @(posedge clk)
begin
	if(CommEnable)
		C = ($signed(mod) > $signed(carrier));
end

assign P = C;

endmodule
